<%@ page import="java.util.*, java.sql.*, java.io.* "%>
<%@ page import="java.sql.Connection, java.sql.DriverManager, java.sql.SQLException" %>
<%@ page import="java.util.*,java.sql.*,java.io.*,org.jdom.*,org.jdom.input.*,org.jdom.output.*,org.jdom.transform.*,javax.xml.transform.*,javax.xml.transform.stream.*,java.util.*,java.io.*" %>


<%

final String TEXT_TYPE = "urn:mpeg:mpeg21:did/statement-types/text/plain";
final String XML_TYPE = "urn:mpeg:mpeg21:did/statement-types/text/xml";

// Get the user info and the sheet
String firstName = request.getParameter("first_name");
String lastName = request.getParameter("last_name");

String cmds[] = new String[2];
    
String dia = new String();

//Initialize the SQL connection
Connection conn  = null;
Class.forName("com.mysql.jdbc.Driver").newInstance();
conn = DriverManager.getConnection("jdbc:mysql://localhost.localdomain/grp2?user=grp2&password=grp2");



// Get the parameters from the previous page      
String password = request.getParameter("password");
String submit = request.getParameter("submit");

int id = Integer.parseInt(request.getParameter("select"));
String width="",height="";
String res = "small";
String framerate="20";

if (submit!=null && submit.equals("submit")){
  // pick the custom video resolution
  res = request.getParameter("res");
  if (res.equals("small")){
     width="128";
     height="96"; 
  }else{
     width="320";
     height="240";
  }
  framerate = request.getParameter("framerate"); 
}else{//use the default resolution
  Statement sti = conn.createStatement();
  ResultSet rsi = sti.executeQuery("SELECT framerate,video_width,video_height FROM user where first_name='"+firstName+"' AND last_name='"+lastName+"' AND password='"+password+"'");
  rsi.next();
  width = rsi.getString("video_width");
  height = rsi.getString("video_height");		
  framerate=rsi.getString("framerate");
}
	

Statement st = conn.createStatement();
ResultSet rs = st.executeQuery("SELECT * FROM user WHERE first_name=\""+firstName+"\" AND last_name=\""+lastName+"\"");
rs .next();
     
// Generate the modality
int iModality = rs.getInt("modality");
String sModality="";
if (iModality==1 || iModality==2){
   sModality="<Modality href=\"urn:mpeg:mpeg21:2003:01-DIA-ModalityCS-NS:1 \" priorityLevel=\"3\">"+
             "  <mpeg7:Name>Video</mpeg7:Name>"+
             "</Modality>"+
             "<Modality href=\"urn:mpeg:mpeg21:2003:01-DIA-ModalityCS-NS:1 \" priorityLevel=\"2\">"+
             "  <mpeg7:Name>Audio</mpeg7:Name>"+
             "</Modality>";
}else if (iModality==3 || iModality==4){
   sModality="<Modality href=\"urn:mpeg:mpeg21:2003:01-DIA-ModalityCS-NS:1 \" priorityLevel=\"2\">"+
             "  <mpeg7:Name>Audio</mpeg7:Name>"+
             "</Modality>";
}
            
// get the framerate and color depth
int cDepth = rs.getInt("depth");
      
// get the video resolution
/*int vHeight = rs.getInt("video_height");
  int vWidth = rs.getInt("video_width");*/
      
// get the frequency data and audio channels
int freqRangeLow = rs.getInt("freq_range_low");
int freqRangeHigh = rs.getInt("freq_range_high");
int frequency = rs.getInt("freq");
int numChannels = rs.getInt("channels");
      
      
// get the available codecs
String vCodec = rs.getString("vcodec");
String aCodec = rs.getString("acodec");
String iCodec = rs.getString("icodec");
      
// get the bandwidth info
int maxBandwidth = rs.getInt("max_bandwidth");
int minBandwidth = rs.getInt("min_bandwidth");

// Construct the DIA
dia = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"+
      "<DIA xmlns:mpeg7=\"urn:mpeg:mpeg7:schema:2001\" xmlns:xsi=\"http://www.w3.org/2000/10/XMLSchema-instance\">"+
      " <Description xsi:type=\"UsageEnvironmentType\">"+
      "  <UsageEnvironment xsi:type=\"UserCharacteristicsType\">"+
      "    <UserCharacteristics xsi:type=\"UserInfoType\">"+
      "      <UserInfo xsi:type=\"mpeg7:PersonType\">"+
      "       <mpeg7:Name>"+
      "        <mpeg7:GivenName>"+firstName+"</mpeg7:GivenName>"+
      "        <mpeg7:FamilyName>"+lastName+"</mpeg7:FamilyName>"+
      "       </mpeg7:Name>"+
      "     </UserInfo>"+
      "   </UserCharacteristics>"+
      "   <UserCharacteristics xsi:type=\"PresentationPreferenceType\"> "+
      "     <PresentationPriority>"+
      "       <GeneralResourcePriorities>"+
      "         <ModalityPriorities>"+sModality+"</ModalityPriorities>"+
      "       </GeneralResourcePriorities>"+
      "     </PresentationPriority>"+
      "    </UserCharacteristics>"+
      "  </UsageEnvironment>"+
      "  <UsageEnvironment xsi:type=\"TerminalCapabilitiesType\">" +
      "    <TerminalCapabilities xsi:type=\"InputOutputCapabilitiesType\">"+
      "      <Display bitsPerPixel=\""+cDepth+"\" refreshRate=\""+framerate+"\">"+
      "        <Resolution horisontal=\""+width+"\" vertical=\""+height+"\"></Resolution> "+
      "      </Display>"+
      "      <AudioOut highFrequency=\""+freqRangeHigh+"\" lowFrequency=\""+freqRangeLow+"\" numChannels=\""+numChannels+"\" samplingFrequency=\""+frequency+"\"></AudioOut>"+
      "    </TerminalCapabilities>"+
      "    <TerminalCapabilities xsi:type=\"CodecCapabilitiesType\">"+
      "      <Decoding xsi:type=\"AudioCapabilitiesType\">"+
      "        <Format href=\"urm:mpeg:mpeg7:cs:AudioCodingFormatCS:2001:4.4\">"+
      "           <mpeg7:Name xml:lang=\"en\">"+aCodec+"</mpeg7:Name>"+
      "        </Format>"+
      "      </Decoding>"+
      "      <Decoding xsi:type=\"VideoCapabilitiesType\">"+
      "        <Format href=\"urm:mpeg:mpeg7:cs:VisualCodingFormatCS:2001:4.4\">"+
      "           <mpeg7:Name xml:lang=\"en\">"+vCodec+"</mpeg7:Name>"+
      "        </Format>"+
      "      </Decoding>"+
      "      <Decoding xsi:type=\"ImageCapabilitiesType\">"+
      "        <Format href=\"urm:mpeg:mpeg7:cs:VisualCodingFormatCS:2001:4.4\">"+
      "           <mpeg7:Name xml:lang=\"en\">"+iCodec+"</mpeg7:Name>"+
      "        </Format>"+
      "      </Decoding>"+
      "    </TerminalCapabilities>"+
      "  </UsageEnvironment>"+
      "  <UsageEnvironment xsi:type=\"NetworkCharacteristicsType\">"+
      "    <NetworkCharacteristics maxCapacity=\""+minBandwidth+"\" minGuaranteed=\""+maxBandwidth+"\" xsi:type=\"NetworkCharacteristicsType\"></NetworkCharacteristics>"+
      "  </UsageEnvironment>"+
      " </Description></DIA>";


// Create the temprorary file to hold the DIA
File currentDir111 = new File ("/home/grp2/jakarta-tomcat-5.5.9/webapps/ROOT/interface/");
File tmpDidl111 = File.createTempFile("dia",".xml",currentDir111);

BufferedWriter outFile111 = new BufferedWriter(new FileWriter(tmpDidl111.getAbsolutePath()));
outFile111.write(dia);
outFile111.close();

// Build the DOM of the dia and the command line trasnformation
SAXBuilder builder = new SAXBuilder();
Reader xmlReader = new StringReader(dia);
File transform = new File("/home/grp2/web/command.xsl");
      
StreamSource sTransform = new StreamSource(transform);
TransformerFactory tFactory = TransformerFactory.newInstance();
Transformer transformer = tFactory.newTransformer(sTransform);
StreamSource source = new StreamSource(xmlReader);
StringWriter strWriter = new StringWriter();
StreamResult result = new StreamResult(strWriter);
transformer.transform(source, result);
String strOutput = strWriter.getBuffer().toString();
Reader cmdReader = new StringReader(strOutput);
// Build the command as a XML
Document cmdXML = builder.build(cmdReader);
Element root = cmdXML.getRootElement();
// Get all the command line arguments
List commands = root.getChildren();
Iterator i = commands.iterator();
String videoCmd="", audioCmd="";
while (i.hasNext()){
  Element cmd = (Element)i.next();
  String type = cmd.getAttributeValue("id");
  if (type.equals("video"))
     videoCmd=cmd.getText();
  else
     audioCmd=cmd.getText();
}
   
cmds[0]=videoCmd;
cmds[1]=audioCmd;

// We do some renaming here
String first = firstName;
String last = lastName;
String pass = password;

// If we come from a page where sheet is pre-defined, get it
String sheet = request.getParameter("sheet");

Statement st123= conn.createStatement();
ResultSet rs123 = st123.executeQuery("SELECT id FROM user WHERE first_name='"+firstName+"' AND last_name='"+lastName+"' AND password='"+password+"'");
rs123.next();
int userID = rs123.getInt("id");
String tmpQuery = "SELECT stream FROM metadata where id="+id;
rs123 = st123.executeQuery(tmpQuery);
rs123.next();
// Check if the media is streamed or pre-recorded
String stream = rs123.getString("stream");
if (sheet==null){
   String mainQuery = "SELECT id, location, param_sum FROM  (    SELECT s.id, s.location,      (ABS(s.modality-ui.modality)/ui.modality+ABS(s.bitrate-ui.bitrate)/ui.bitrate+ABS(s.framerate-ui.framerate)/ui.framerate+       ABS(s.resolution-ui.resolution)/ui.resolution+ABS(s.depth-ui.depth)/ui.depth+ABS(s.freq-ui.freq)/ui.freq+ABS(s.channels-ui.channels)/ui.channels+       ABS(s.image_resolution-ui.image_resolution)/ui.image_resolution+ABS(s.video-ui.video)/ui.video+ABS(s.audio-ui.audio)/ui.audio+       ABS(s.image-ui.image)/ui.image      ) AS param_sum       FROM user ui,           (SELECT s.id,s.modality,s.bitrate,s.framerate,s.resolution,s.depth,s.freq,s.channels,s.image_resolution,s.video,s.audio,s.image,s.location FROM sheet s, user ui           WHERE           ui.modality >= s.modality AND ui.bitrate >= s.bitrate AND ui.framerate >= s.framerate AND ui.resolution >= s.resolution AND ui.depth>= s.depth AND ui.freq>=s.freq AND ui.channels>=s.channels AND ui.image_resolution>=s.image_resolution AND ui.video>=s.video AND ui.audio>=s.audio AND ui.image>=s.image AND ui.id="+userID+" AND vwidth="+width+" AND vheight="+height+" AND s.stream="+stream+"         )s WHERE ui.id="+userID+"      )result_table WHERE param_sum= (   SELECT min(param_sum)   FROM  (     SELECT s.id, s.location,      (ABS(s.modality-ui.modality)/ui.modality+ABS(s.bitrate-ui.bitrate)/ui.bitrate+ABS(s.framerate-ui.framerate)/ui.framerate+       ABS(s.resolution-ui.resolution)/ui.resolution+ABS(s.depth-ui.depth)/ui.depth+ABS(s.freq-ui.freq)/ui.freq+ABS(s.channels-ui.channels)/ui.channels+       ABS(s.image_resolution-ui.image_resolution)/ui.image_resolution+ABS(s.video-ui.video)/ui.video+ABS(s.audio-ui.audio)/ui.audio+       ABS(s.image-ui.image)/ui.image      ) AS param_sum      FROM user ui, (SELECT s.id,s.modality,s.bitrate,s.framerate,s.resolution,s.depth,s.freq,s.channels,s.image_resolution,s.video,s.audio,s.image,s.location FROM sheet s, user ui WHERE ui.modality >= s.modality AND ui.bitrate >= s.bitrate AND ui.framerate >= s.framerate AND ui.resolution >= s.resolution AND ui.depth>= s.depth AND ui.freq>=s.freq AND ui.channels>=s.channels AND ui.image_resolution>=s.image_resolution AND ui.video>=s.video AND ui.audio>=s.audio AND ui.image>=s.image AND ui.id="+userID+" AND vheight="+height+" AND vwidth="+width+" AND s.stream="+stream+"  )s      WHERE ui.id="+userID+"   )result_table)";
   rs123 = st123.executeQuery(mainQuery);
   rs123.next();
   sheet = rs123.getString("location");
}

builder = new SAXBuilder();
XMLOutputter outp = new XMLOutputter(Format.getPrettyFormat());
Statement chaptersST;
ResultSet chaptersRS;
st = conn.createStatement();
rs = st.executeQuery("SELECT * FROM metadata WHERE id="+id);

// Create the DIDL
String didl="<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?><DIDL xmlns=\"urn:mpeg:mpeg21:2002:01-DIDL-NS\"\n\t";
rs.next();
int lectureId = Integer.parseInt(rs.getString("id"));
String lectureTitle = rs.getString("title");
String comment = rs.getString("comment");
String department = rs.getString("department");
String prof = rs.getString("professor");
String course = rs.getString("class_id");
String courseName = rs.getString("course_name");
String uni = rs.getString("university");
String logoLocation = rs.getString("logo");

String declarations = "<DECLARATIONS>";
chaptersST = conn.createStatement();
chaptersRS = chaptersST.executeQuery("SELECT * FROM chapters WHERE lecture_id="+id+" ORDER BY chapter_number");
   	
// Get the number of chapters and create the temprorary files for each video
Statement tmpSt = conn.createStatement();
ResultSet numChapters = tmpSt.executeQuery("SELECT COUNT(*) as num_chapters FROM chapters WHERE lecture_id="+id);
numChapters.next();

// Create the playlist
int nChapters = numChapters.getInt("num_chapters");
File tmpDir = new File("/home/grp2/web/tmp");
File tmpVidFiles[] = new File[nChapters];
File tmpSndFiles[] = new File[nChapters];
File tmpPlayList = File.createTempFile("list",".asx",tmpDir);

String playListContent = "<ASX version=\"3.0\"><REPEAT>";
String playListLocation = "http://wwwtest.dsp.utoronto.ca/interface/tmp/"+tmpPlayList.getAbsolutePath().substring("/home/grp2/web/tmp/".length(),tmpPlayList.getAbsolutePath().length());
for (int cntr=0;cntr<nChapters;cntr++){
	tmpVidFiles[cntr] = File.createTempFile("vid",".asf",tmpDir);
 	tmpSndFiles[cntr] = File.createTempFile("snd",".mp3",tmpDir);
 	String tmpVidLoc = "http://wwwtest.dsp.utoronto.ca/interface/tmp/"+tmpVidFiles[cntr].getAbsolutePath().substring("/home/grp2/web/tmp/".length(),tmpVidFiles[cntr].getAbsolutePath().length());
 	playListContent += "<ENTRY>";
 	playListContent += "<REF HREF=\""+tmpVidLoc+"\"/></ENTRY>";
}
playListContent += "</REPEAT></ASX>";



 	
ResultSet mpeg7Result = st.executeQuery("SELECT * FROM mpeg7 WHERE lecture_id="+lectureId);
while (mpeg7Result.next()){// Create the mpeg-7 header
   int schemeID = Integer.parseInt(mpeg7Result.getString("scheme"));
   String locationMpeg7 = mpeg7Result.getString("location");
   String desc = mpeg7Result.getString("description");
   String desc_text = mpeg7Result.getString("description_text");
   Statement st2 = conn.createStatement();
   ResultSet schemeResult = st2.executeQuery("SELECT * FROM schemes WHERE id="+schemeID);
   schemeResult.next();
   String namespace = schemeResult.getString("namespace");
   String location = schemeResult.getString("location");

   // Add the namespace
   didl += " xmlns:"+namespace+"=\""+location+"\" \n\t";

   // Add the declarations
   declarations += "\n  <DESCRIPTOR ID=\""+desc+"\">";
   declarations += "\n    <DESCRIPTOR><STATEMENT TYPE=\""+TEXT_TYPE+"\"> "+desc_text+" </STATEMENT></DESCRIPTOR>";
   declarations += "\n    <STATEMENT TYPE=\""+XML_TYPE+"\">";
   declarations += "\n       <REFERENCE URI=\""+locationMpeg7+"\" />";
   declarations += "\n    </STATEMENT></DESCRIPTOR>";
}
    
didl += ">";
didl += "\n"+declarations + "\n  </DECLARATIONS>\n";
didl += "\n  <CONTAINER>";

didl += "\n    <DESCRIPTOR ID=\"UNIVERSITY\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+uni+"</STATEMENT></DESCRIPTOR>";
didl += "\n    <DESCRIPTOR ID=\"DEPARTMENT\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+department+"</STATEMENT></DESCRIPTOR>";
didl += "\n    <DESCRIPTOR ID=\"PROFESSOR\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+prof+"</STATEMENT></DESCRIPTOR>";
didl += "\n    <DESCRIPTOR ID=\"COURSE\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+course+"</STATEMENT></DESCRIPTOR>";
didl += "\n    <DESCRIPTOR ID=\"LECTURE_TITLE\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+lectureTitle+"</STATEMENT></DESCRIPTOR>";
didl += "\n    <DESCRIPTOR ID=\"LECTURE_DESCRIPTION\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+comment+"</STATEMENT></DESCRIPTOR>";
didl += "\n    <DESCRIPTOR ID=\"LOGO\"><COMPONENT><RESOURCE REF=\""+logoLocation+"\" /></COMPONENT></DESCRIPTOR>"; 
//File.createTempFile("BEFORE",".asf",tmpDir);
File[] sFiles;
if (stream.equals("1")){
	 		String myCommand="";
			// Read the location of the stream files
		    Statement sStm = conn.createStatement();
		    ResultSet sRs = sStm.executeQuery("SELECT location FROM video v, chapters c WHERE c.video = v.id AND c.lecture_id="+lectureId+" AND chapter_number=1");
		    sRs.next();
			String videoLocation = sRs.getString("location");
	 	    // Read the current file and the number of files left
	 	    File currentFile = new File(videoLocation+"current.chp");
	 	    FileInputStream fstream = new FileInputStream(currentFile);
	 	    
	 	    DataInputStream in = new DataInputStream(fstream);
	 	    String line1 = in.readLine();
	 	    String line2 = in.readLine();
	 	    fstream.close();
	 	    	 	    
	 	    int left = Integer.parseInt(line1);
	 	    int current = Integer.parseInt(line2);
	 	    
	 	    File streamDir = new File(videoLocation);
	 	    File sTmpDir = new File("/home/grp2/web/tmp");
	 	    playListContent = "<ASX version=\"3.0\">";
	 	    sFiles= new File[left];
	 	     
	 	    for (int c=current;c<current+left;c++){
		 	    sFiles[c-current] = File.createTempFile("entry",".asf",sTmpDir);
	 	    }
	 	    
	 	    int delayTime = 0;
	 	    for (int c=current;c<current+left;c++){
		 	   myCommand = "";
		 	   String srcFile = videoLocation+"stream"+c+".asf";
		 	   File sTmpFile = sFiles[c-current];
			   playListContent += "<ENTRY>";
			   String sVideoLocation = "http://wwwtest.dsp.utoronto.ca/interface/tmp/"+sTmpFile.getAbsolutePath().substring("/home/grp2/web/tmp/".length(),sTmpFile.getAbsolutePath().length());
			   playListContent += "<REF HREF=\""+sVideoLocation+"\" />";
	 		
			   playListContent += "</ENTRY>";
			   
			  
			   // If there is video
		 	   if (cmds[0]!=null && !cmds[0].equals("")){
			 	 if (c==current)
            	    myCommand = "ffmpeg -i "+srcFile+" "+cmds[0]+" ";
            	 else
            	    myCommand += "ffmpeg -i "+srcFile+" "+cmds[0]+" ";
         	   } 
         	   // If there is audio
	 		   if (cmds[1]!=null && !cmds[1].equals("")){
             	 myCommand += " " + cmds[1]+" ";
       		   }	 	   
       		   myCommand += sTmpFile.getAbsolutePath();
       		          		  	       		     
       		   if (c==current){
	       		
       		    Process encode = Runtime.getRuntime().exec(myCommand);
       		    //out.print(myCommand);
       		   	encode.waitFor();
       		   	
       		   	// Copy the original file into the other ones to fool WMP:)
       		   	String firstFileName = sFiles[0].getAbsolutePath();
       		   	for (int fCounter=1;fCounter<left;fCounter++){
	       		   	String currFileName = sFiles[fCounter].getAbsolutePath();
	       		   	String cp = "cp -f "+firstFileName+" "+currFileName;
	       		   	Process copy = Runtime.getRuntime().exec(cp);
	       		   	copy.waitFor();
       		   	}
       		   	
       		   	c++;
       		   	myCommand = "";
		 	    srcFile = videoLocation+"stream"+c+".asf";
		 	    sTmpFile = sFiles[c-current];
			    playListContent += "<ENTRY>";
			    sVideoLocation = "http://wwwtest.dsp.utoronto.ca/interface/tmp/"+sTmpFile.getAbsolutePath().substring("/home/grp2/web/tmp/".length(),sTmpFile.getAbsolutePath().length());
			    playListContent += "<REF HREF=\""+sVideoLocation+"\" />";
	 			playListContent += "</ENTRY>";
			   
			    // If there is video
		 	    if (cmds[0]!=null && !cmds[0].equals("")){
			 	  if (c==current)
            	     myCommand = "ffmpeg -i "+srcFile+" "+cmds[0]+" ";
            	  else
            	     myCommand += "ffmpeg -i "+srcFile+" "+cmds[0]+" ";
         	    } 
         	    // If there is audio
	 		    if (cmds[1]!=null && !cmds[1].equals("")){
              	  myCommand += " " + cmds[1]+" ";
       		    }	 	   
       		    myCommand += sTmpFile.getAbsolutePath();
       		   	encode = Runtime.getRuntime().exec(myCommand);
       		    //out.print(myCommand);
       		   	encode.waitFor();
       		   
       		   	
       		   	
       		   	//
       		   	//out.print("Copied Everything");
       		   	//Thread.sleep(15000);
   		   	   }else{
	   		   	myCommand = "/home/grp2/web/encode.sh "+delayTime+" "+myCommand;
	   		   	//out.print(myCommand);
	   		   	Process encode = Runtime.getRuntime().exec(myCommand);
   		   	   }
       		   delayTime +=17;
	 	    }
	 	    
	 	    playListContent +=  "</ASX>";
		 	
}
// Write the playlist to a file
FileOutputStream playListOut = new FileOutputStream(tmpPlayList);
PrintStream p =  new PrintStream( playListOut );
p.print (playListContent);
p.close();
didl += "\n    <DESCRIPTOR ID=\"PLAYLIST\"><COMPONENT><RESOURCE REF=\""+playListLocation+"\" /></COMPONENT></DESCRIPTOR>";
//File.createTempFile("AFTER",".asf",tmpDir);
int counter=0;
while (chaptersRS.next()){
   int chapterID = chaptersRS.getInt("id");
   int videoID = chaptersRS.getInt("video");
   int audioID = chaptersRS.getInt("audio");
   int chapterNumber = chaptersRS.getInt("chapter_number");
   String chapterComment = chaptersRS.getString("comment");
   didl += "\n    <ITEM ID=\""+chapterNumber+"\" >";
   didl += "\n      <DESCRIPTOR ID=\"CHAPTER_TITLE\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+chapterComment+"</STATEMENT></DESCRIPTOR>";
   if (videoID>0&&stream.equals("0")){ // if there is a video add it to the Digital Item
        Statement videoStatement = conn.createStatement();
        ResultSet videoRS = videoStatement.executeQuery("SELECT * FROM video WHERE id="+videoID);
        videoRS.next();
        String videoLocation = videoRS.getString("location");
        String myCommand = "";
 	    String cmd="";
	   
 	    if (cmds[0]!=null && !cmds[0].equals("")){
            myCommand = "ffmpeg -i "+videoLocation+" "+cmds[0]+" ";
         } 

	 	if (cmds[1]!=null && !cmds[1].equals("")){
             myCommand += " " + cmds[1]+" ";
       	}
 	
       	myCommand += tmpVidFiles[counter].getAbsolutePath();
       	Process ps9= Runtime.getRuntime().exec("ls");
       	if (!(sheet.equals("pda.xsl")) && !(sheet.equals("slides_pda.xsl")) && !(sheet.equals("chat_pda.xsl")) && !(sheet.equals("smartphone.xsl")) && !(sheet.equals("slides.xsl")))
       		ps9= Runtime.getRuntime().exec(myCommand);
    	if (counter==0&&stream.equals("0"))
       		ps9.waitFor();
    	else if (stream.equals("1"))
			Thread.sleep(1000);
		
		//out.print(myCommand); 	
	
		videoLocation = "http://wwwtest.dsp.utoronto.ca/interface/tmp/"+tmpVidFiles[counter].getAbsolutePath().substring("/home/grp2/web/tmp/".length(),tmpVidFiles[counter].getAbsolutePath().length());
	
        String videoComment = videoRS.getString("comment");
        String thumbnailLocation = videoRS.getString("thumbnail_location");
        String format = videoRS.getString("format");
        String videoLength = videoRS.getString("length");
        didl += "\n   <COMPONENT ID=\"VIDEO\">";
        didl += "\n      <DESCRIPTOR ID=\"VIDEO_DESC\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+videoComment+"</STATEMENT></DESCRIPTOR>";
        didl += "\n      <DESCRIPTOR ID=\"VIDEO_FORMAT\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+format+"</STATEMENT></DESCRIPTOR>";
        didl += "\n      <DESCRIPTOR ID=\"VIDEO_LENGTH\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+videoLength+"</STATEMENT></DESCRIPTOR>";
        didl += "\n      <DESCRIPTOR ID=\"THUMBNAIL\"><COMPONENT><RESOURCE REF=\""+thumbnailLocation+"\" /></COMPONENT></DESCRIPTOR>";
        didl += "\n      <RESOURCE REF=\""+videoLocation+"\" TYPE=\"video/"+format+"\" />";
        didl += "\n   </COMPONENT>";
   }else if (stream.equals("1")){
	 /*for (int cVids=0;cVids<sFiles.length;cVids++){
	   String sLocation = sFiles[cVids].substring(sFiles[cVids].indexOf("/home/grp2/web/"),sFiles[cVids].size());
	   sLocation = "http://wwwtest.dsp.utoronto.ca/interface/"+sLocation;
	   didl += "\n    <COMPONENT ID=\"VIDEO\">";
	   didl += "\n      <DESCRIPTOR ID=\"SEQUENCE_NUMBER\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+(cVids+1)+"</STATEMENT></DESCRIPTOR>";
	   didl += "\n      <DESCRIPTOR ID=\"VIDEO_FORMAT\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+"msmpeg4v2"+"</STATEMENT></DESCRIPTOR>"; 
	   didl += "\n      <DESCRIPTOR ID=\"VIDEO_LENGTH\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+"15"+"</STATEMENT></DESCRIPTOR>";
	   didl += "\n      <DESCRIPTOR ID=\"THUMBNAIL\"><COMPONENT><RESOURCE REF=\""+"none"+"\" /></COMPONENT></DESCRIPTOR>";
	   didl += "\n      <RESOURCE REF=\""+videoLocation+"\" TYPE=\"video/"+sLocation+"\" />";
	   didl += "\n   </COMPONENT>";
     } */
   }
	 
   if (audioID>0&&stream.equals("0")){
      Statement audioStatement = conn.createStatement();
      ResultSet audioRS = audioStatement.executeQuery("SELECT * FROM audio WHERE id="+audioID);
      audioRS.next();
      String audioLocation = audioRS.getString("location");
      if (counter==0){
          audioLocation =  "http://wwwtest.dsp.utoronto.ca/interface/tmp/"+tmpSndFiles[counter].getAbsolutePath().substring("/home/grp2/web/tmp/".length(),tmpVidFiles[counter].getAbsolutePath().length());
      }
      String audioComment = audioRS.getString("comment");
      String format = audioRS.getString("format");
      didl += "\n   <COMPONENT ID=\"AUDIO\">";
      didl += "\n      <DESCRIPTOR ID=\"AUDIO_DESC\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+audioComment+"</STATEMENT></DESCRIPTOR>";
      didl += "\n      <DESCRIPTOR ID=\"AUDIO_FORMAT\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+format+"</STATEMENT></DESCRIPTOR>";
      didl += "\n      <RESOURCE REF=\""+audioLocation+"\" TYPE=\"audio/"+format+"\" />";
      didl += "\n   </COMPONENT>";
   }
   
   Statement slidesStatement = conn.createStatement();
   ResultSet slidesRS = slidesStatement.executeQuery("SELECT * FROM slides WHERE chapter_id="+chapterID+" ORDER BY sequence_id");
   didl += "\n    <COMPONENT ID=\"SLIDES\">";
   int totalTime = 0;
   int hasTimestamp=0;
   while (slidesRS.next()){
        int sequenceID = Integer.parseInt(slidesRS.getString("sequence_id"));
        int duration = Integer.parseInt(slidesRS.getString("duration"));
        String slideLocation = slidesRS.getString("location");
        String slideFormat = slidesRS.getString("type");
        hasTimestamp = slidesRS.getInt("timestamps");
        didl += "\n     <ANCHOR FRAGMENT=\""+duration+"\">";
        didl += "\n        <DESCRIPTOR ID=\"SLIDE_NUMBER\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+sequenceID+"</STATEMENT></DESCRIPTOR>";
        didl += "\n        <DESCRIPTOR ID=\"SLIDE_LOCATION\"><COMPONENT><RESOURCE REF=\""+slideLocation+"\" TYPE=\"image/"+slideFormat+"\" /></COMPONENT></DESCRIPTOR>";
        didl += "\n     </ANCHOR>";
        totalTime += duration;
   }

   didl += "<DESCRIPTOR ID=\"HAS_TIMESTAMP\"><STATEMENT TYPE=\""+TEXT_TYPE+"\">"+hasTimestamp+"</STATEMENT></DESCRIPTOR>";
   // Create an empty resource
   didl += "<RESOURCE REF=\"empty\" TYPE=\"empty\" />";
   didl += "\n      </COMPONENT>";
   didl += "\n    </ITEM>";
   counter++;
}// end while loop
    
didl += "\n  </CONTAINER>";
didl += "\n</DIDL>";

// Get the sheet and apply the transformation for the interface
Reader xslReader = new StringReader(didl);
transform = new File("/home/grp2/jakarta-tomcat-5.5.9/webapps/ROOT/interface/"+sheet);
sTransform = new StreamSource(transform);
tFactory = TransformerFactory.newInstance();
transformer = tFactory.newTransformer(sTransform);
source = new StreamSource(xslReader);

strWriter = new StringWriter();
result = new StreamResult(strWriter);
transformer.transform(source, result);

strOutput = strWriter.getBuffer().toString();

// Create a temprorary file to store the DI	
File currentDir = new File ("/home/grp2/jakarta-tomcat-5.5.9/webapps/ROOT/interface/");
File tmpDidl = File.createTempFile("didl",".xml",currentDir);
BufferedWriter outFile = new BufferedWriter(new FileWriter(tmpDidl.getAbsolutePath()));
outFile.write(didl);
outFile.close();
  

if (sheet.equals("pc2.xsl")||sheet.equals("pc3.xsl")){          
// Add links to all temprorary files        
String didlName = "http://wwwtest.dsp/interface/"+tmpDidl.getName();
String diaName = "http://wwwtest.dsp/interface/"+tmpDidl111.getName();
String transformName = "http://wwwtest.dsp/interface/"+sheet;
strOutput += "<a href=\"javascript:popUp('"+didlName+"')\"> Digital Item </a>&nbsp;&nbsp;";
strOutput += "<a href=\"javascript:popUp('"+sheet+"')\"> XSLT Sheet </a>&nbsp;&nbsp;";
strOutput += "<a href=\"javascript:popUp('mazen.mp7')\"> MPEG-7 Motion Description </a>&nbsp;&nbsp;";
strOutput += "<a href=\"javascript:popUp('"+diaName+"')\"> DIA </a>";

// Display a link to the sheets
/*strOutput += "<br /><a href=\"javascript:popUp('command.xml')\"> The Command Line </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('pc2.xml')\"> pc2.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('pc3.xml')\"> pc3.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('pcs.xml')\"> pcs.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('pcss.xml')\"> pcss.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('pda.xml')\"> pda.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('slides_pda.xml')\"> slides_pda.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('video_pda.xml')\"> video_pda.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('smartphone.xml')\"> smartphone.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('video.xml')\"> video.xsl </a>&nbsp;&nbsp;";
strOutput += "<br /><a href=\"javascript:popUp('slides.xml')\"> slides.xsl </a>&nbsp;&nbsp;";
*/
}
// Add the hidden fields
if (sheet.equals("smartphone.xsl")||sheet.equals("video.xsl")||sheet.equals("slides.xsl")||
    sheet.equals("pda.xsl")||sheet.equals("video_pda.xsl")||sheet.equals("video_chat_pda.xsl")||
    sheet.equals("slides_pda.xsl")||sheet.equals("slides_chat_pda.xsl")){
	
	  int ind = strOutput.indexOf("<table");
      String begining = strOutput.substring(0,ind);
	  String end = strOutput.substring(ind,strOutput.length());
      String intermidiate = "		<input type=\"hidden\" name=\"first_name\" value=\""+firstName+"\" />		<input type=\"hidden\" name=\"last_name\" value=\""+lastName+"\" />			<input type=\"hidden\" name=\"password\" value=\""+password+"\" />   <input type=\"hidden\" name=\"select\" value=\""+id+"\" /><input type=\"hidden\" name=\"res\" value=\""+res+"\" />";
	  strOutput = begining+intermidiate+end;
}else if (sheet.equals("pc.xsl")){
      int ind = strOutput.indexOf("<input id=\"pauseBtn");
      String begining = strOutput.substring(0,ind);
      String end = strOutput.substring(ind,strOutput.length());
      String intermidiate = "         <input type=\"hidden\" name=\"first_name\" value=\""+firstName+"\" />           <input type=\"hidden\" name=\"last_name\" value=\""+lastName+"\" />                     <input type=\"hidden\" name=\"password\" value=\""+password+"\" />   <input type=\"hidden\" name=\"select\" value=\""+id+"\" />";
	  strOutput = begining+intermidiate+end;
}	

// Print the generated interface
out.print(strOutput);

%>
